/* Usage: java swarm_test <P> <output_file>
 * P is the number of planets (1 <= P <= 1000).
 * seed is a 64-bit integer used to seed the random number generator.
 *
 * Generated inputs may have more than one valid output.
 * The inputs in the zip archive have been filtered to remove ambiguous planets.
 */
import java.util.Arrays;
public class swarm_test {
	public static void main(String[] args) {
		int P = Integer.parseInt(args[0]);
		if (P < 1 || 1000 < P) {
			System.exit(1);
		}
		long seed = Long.parseLong(args[1]);
		java.util.Random r = new java.util.Random(seed);
		Spacer sp = new Spacer(args[2]);
		sp.print(P);
		sp.println();
		while (P-- > 0) {
			int T = (int)Math.round(Math.pow(1000, r.nextDouble()));
			sp.print(T);
			sp.print(" ");
			sp.print(1 + r.nextInt(999));
			sp.println();
			int[] s = new int[T];
			int[] m = new int[T];
			for (int i = 0; i < T; i++) {
				s[i] = 1 + r.nextInt(399);
				m[i] = 1 + r.nextInt(399);
			}
			Arrays.sort(s);
			Arrays.sort(m);
			for (int i = 0; i < T; i++) {
				sp.print(s[i]);
				sp.print(" ");
				sp.print(m[i]);
				sp.println();
			}
		}
		sp.close((int)seed % 3);
	}
}
